﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Runtime.Serialization;
using HeuristicLab.Common;
using HeuristicLab.DataAccess;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {

  [StorableClass]
  [DataContract]
  [Serializable]
  public class HiveExperimentDto : PersistableObject {
    [Storable]
    [DataMember]
    public string Name { get; set; }
    [Storable]
    [DataMember]
    public string Description { get; set; }
    [Storable]
    [DataMember]
    public string ResourceIds { get; set; }
    [Storable]
    [DataMember]
    public Guid UserId { get; set; }
    [Storable]
    [DataMember]
    public Guid? RootJobId { get; set; }

    public override string ToString() {
      return base.ToString() + "Name: " + Name + ", Description: " + Description + ", ResourceIds: " + ResourceIds;
    }

    public HiveExperimentDto() {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      HiveExperimentDto clone = (HiveExperimentDto)base.Clone(cloner);
      clone.Name = this.Name;
      clone.Description = this.Description;
      clone.ResourceIds = this.ResourceIds;
      clone.RootJobId = this.RootJobId;
      clone.UserId = this.UserId;
      return clone;
    }
  }
}
