﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;

namespace HeuristicLab.Hive.Contracts.Interfaces {
  /// <summary>
  /// Manages the lifecycle of the application
  /// </summary>
  public interface ILifecycleManager {
    /// <summary>
    /// Initializes the application
    /// </summary>
    void Start();

    /// <summary>
    /// Shuts the application down
    /// </summary>
    void Stop();

    /// <summary>
    /// The number of jobs which are transferred at the moment
    /// </summary>
    int JobsCurrentlyTransferring { get; set; }

    event EventHandler ServerHeartbeat;

    event EventHandler Started;

    event EventHandler Stopped;
  }
}
