﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Xml;
using System.Threading;
using System.IO;
using System.Security.Permissions;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.JobBase {
  [Serializable]
  [StorableClass]
  public class TestJob: JobBase {

    [Storable]
    private int runValue = 0;

    public TestJob() {
    }

    public override void Run() {
      int max = 100;
      while(runValue < max && abort == false) {
        //for (int y = 0; y < Int32.MaxValue; y++) ;
        Thread.Sleep(200);   
        if (abort == true) {            
          Debug.WriteLine("Job Abort Processing");
          break;
        }
        runValue++;
        Progress = (double)runValue / max;        
        Debug.WriteLine("Iteration " + runValue + " done");
        Debug.WriteLine("Progress " + Progress*100 + " Percent");
      }      
      OnJobStopped();
    }

    //public override System.Xml.XmlNode GetXmlNode(string name, System.Xml.XmlDocument document, IDictionary<Guid, HeuristicLab.Core.IStorable> persistedObjects) {      
    //  XmlNode node = base.GetXmlNode(name, document, persistedObjects);
    
    //  XmlNode startValue = document.CreateNode(XmlNodeType.Element, "StartValue", null);
    //  startValue.InnerText = Convert.ToString(runValue);
      
    //  node.AppendChild(startValue);
    //  return node;
    //}

    //public override void Populate(XmlNode node, IDictionary<Guid, HeuristicLab.Core.IStorable> restoredObjects) {
    //  base.Populate(node, restoredObjects);

    //  XmlNode startValue = node.SelectSingleNode("StartValue");
    //  runValue = Convert.ToInt32(startValue.InnerText);
    //}
  }
}
